//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 2
#property indicator_level1 0

//
//
//
//
//

extern int                Length   = 50;
extern ENUM_APPLIED_PRICE Price    = PRICE_CLOSE;
extern int                MaLength = 10;
extern ENUM_MA_METHOD     MaMethod = MODE_EMA;
extern double             Smooth   = 5;
extern bool               UseVolumesToo = false;

double mom[];
double histDn[];
double histNe[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,mom);
   IndicatorShortName("Cumulative momentum ("+Length+","+MaLength+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
         
         //
         //
         //
         //
         //
         

   for(int i=limit; i>=0; i--)
   {
      mom[i] = 0;
      double price = iMA(NULL,0,MaLength,0,MaMethod,Price,i);
      if (UseVolumesToo)
            for (int k=0; k<Length; k++) mom[i] += Volume[i+k]*(price-iMA(NULL,0,MaLength,0,MaMethod,Price,i+k));
      else  for (    k=0; k<Length; k++) mom[i] +=              price-iMA(NULL,0,MaLength,0,MaMethod,Price,i+k);
      mom[i] = iSsm(mom[i],Smooth,i);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double workSsm[][2];
#define _tprice  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
      i = Bars-i-1;
          workSsm[i][s+_tprice] = price;
          if (i<2)
               workSsm[i][s+_ssm] = price;
          else workSsm[i][s+_ssm]  = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                     workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                     workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}